using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace CiaoClient
{
    public partial class Options : Form
    {
        public ClientConfiguration ThisConfiguration;

        public Options(ClientConfiguration Conf)
        {
            ThisConfiguration = Conf;
            InitializeComponent();
            InitializeChangeEvent();
        }

        private void Options_Load(object sender, EventArgs e)
        {
            LoadConfiguration();
            this.button3.Enabled = false;
        }

        private void InitializeChangeEvent()
        {
            this.checkBox1.CheckedChanged += new EventHandler(OptionsChange);
            this.checkBox4.CheckedChanged += new EventHandler(OptionsChange);
            this.checkBox5.CheckedChanged += new EventHandler(OptionsChange);
            this.textBox1.TextChanged += new EventHandler(OptionsChange);
            this.textBox2.TextChanged += new EventHandler(OptionsChange);
        }

        private void LoadConfiguration()
        {
            this.checkBox1.Checked = this.ThisConfiguration.HideWhenMinimized;
            this.checkBox4.Checked = this.ThisConfiguration.AllowRsaEncryption;
            this.checkBox5.Checked = this.ThisConfiguration.RequestRsaEncryption;
            this.textBox1.Text = this.ThisConfiguration.ReportServer;
            this.textBox2.Text = Convert.ToString(this.ThisConfiguration.ReportPort);
        }

        private void SaveConfiguration()
        {
            this.ThisConfiguration.HideWhenMinimized = this.checkBox1.Checked;
            this.ThisConfiguration.AllowRsaEncryption = this.checkBox4.Checked;
            this.ThisConfiguration.RequestRsaEncryption = this.checkBox5.Checked;
            this.ThisConfiguration.ReportServer = this.textBox1.Text;
            this.ThisConfiguration.ReportPort = Convert.ToInt32(this.textBox2.Text);
        }

        private void OptionsChange(Object sender, EventArgs e)
        {
            this.button3.Enabled = true;
        }

        private void button1_Click(object sender, EventArgs e)
        {
            //OK
            SaveConfiguration();
            this.Close();
        }

        private void button2_Click(object sender, EventArgs e)
        {
            this.Close();
            //Cancel
        }

        private void button3_Click(object sender, EventArgs e)
        {
            //Apply
            SaveConfiguration();
            this.button3.Enabled = false;
        }
    }
}