using System;
using System.Collections.Generic;
using System.Windows.Forms;
using CiaoStuff;

namespace CiaoClient
{
    static class Program
    {
        [STAThread]
        static void Main()
        {
            Application.EnableVisualStyles();
            Application.SetCompatibleTextRenderingDefault(false);
            Application.ThreadException += new System.Threading.ThreadExceptionEventHandler(Application_ThreadException);
            Application.Run(new MainClientForm());
        }

        static void Application_ThreadException(object sender, System.Threading.ThreadExceptionEventArgs e)
        {
            DialogResult ButtonHit = MessageBox.Show("Details: " + e.Exception.Message + ".\r\nDo you want to report this error?", "Unhandled exception", MessageBoxButtons.YesNo);
            if (ButtonHit == DialogResult.Yes)
            {
                System.Net.IPAddress RemoteIP;
                ClientConfiguration a =(ClientConfiguration)CiaoStuff.Serializer.LoadObject("conf.xml", Serializer.FormatterType.SOAP);
                if (MainClientForm.IsIP(a.ReportServer))
                {
                    RemoteIP = System.Net.IPAddress.Parse(a.ReportServer);
                }
                else
                {
                    RemoteIP = MainClientForm.Resolve(a.ReportServer);
                    if (RemoteIP == null)
                    {
                        MessageBox.Show("Could not resolve report server host name", "Error");
                        return;
                    }
                }
                try
                {
                    CiaoStuff.Report.SendReportToServer(e.Exception, RemoteIP, Convert.ToInt32(a.ReportPort));
                }
                catch (Exception Ex)
                {
                    MessageBox.Show(Ex.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error);
                    return;
                }
                MessageBox.Show("The error report has been sent! We recommend that you restart the application.", "Info", MessageBoxButtons.OK, MessageBoxIcon.Information);
            }
        }
    }
}