using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using CSockets;
using System.Net;

namespace CiaoClient
{
    public partial class SignUpForm : Form
    {
        private Client CiaoClient;

        public SignUpForm()
        {
            CiaoClient = new Client(null, 1);
            CiaoClient.PacketTransmit += new PacketEventHandler(CiaoClient_PacketTransmit);
            InitializeComponent();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            try
            {
                if (CiaoClient.IsConnected)
                {
                    return;
                }
                if (MainClientForm.IsIP(this.textBox1.Text))
                {
                    CiaoClient.RemoteIP = IPAddress.Parse(this.textBox1.Text);
                }
                else
                {
                    CiaoClient.RemoteIP = MainClientForm.Resolve(this.textBox1.Text);
                    if (CiaoClient.RemoteIP == null)
                    {
                        MessageBox.Show(this, "Could not resolve host name", "Error");
                        return;
                    }
                }
                try
                {
                    CiaoClient.Port = Convert.ToInt32(this.textBox2.Text);
                }
                catch
                {
                    MessageBox.Show(this, "Could not parse Port number", "Error", MessageBoxButtons.OK, MessageBoxIcon.Error);
                    return;
                }
                String Email; String Password; String UserLevel;
                if (this.textBox4.Text != this.textBox5.Text)
                {
                    MessageBox.Show(this, "The passwords do not match", "Password");
                    return;
                }
                if (String.IsNullOrEmpty(this.comboBox1.Text))
                {
                    MessageBox.Show(this, "Please select a user level", "User level");
                    return;
                }
                Email = this.textBox3.Text;
                Password = this.textBox4.Text;
                UserLevel = this.comboBox1.Text;

                CiaoClient.Connect();
                PacketData a = new PacketData();
                a.DataCategory = "User"; a.DataType = "Request"; a.DataParameters = "SignUp";
                a.MainData = new String[] { Email, Password, UserLevel };
                Packet p = new Packet(null, a);
                CiaoClient.Send(p.Buffer);
            }
            catch (Exception Ex)
            {
                MessageBox.Show(this, Ex.Message, "Error");
            }
        }

        void CiaoClient_PacketTransmit(object sender, PacketEventArgs e)
        {
            if (e.Direction == PacketDirection.Incoming)
            {
                try
                {
                    PacketData ReceivedData = (PacketData)e.ReceivedPacket.ObjectBuffer;
                    if (ReceivedData.DataCategory == "User" && ReceivedData.DataParameters == "SignUp")
                    {
                        if (ReceivedData.DataType == "Confirmation")
                        {
                            MessageBox.Show(this, "You have signed up!", "Sign up");
                            CiaoClient.Disconnect();
                            this.Close();
                        }
                        else
                        {
                            MessageBox.Show(this, "You have failed to sign up", "Sign up");
                            CiaoClient.Disconnect();
                        }
                    }
                }
                catch { }
            }
        }

        private void button2_Click(object sender, EventArgs e)
        {
            if (CiaoClient.IsConnected)
            {
                CiaoClient.Disconnect();
            }
            this.Close();
        }
    }
}