using System;
using System.Collections.Generic;
using System.Text;

namespace CiaoServer
{
    [Serializable]
    public class User
    {
        private String email;
        private String password;
        private String nickname;
        private UserLevel level;
        private DateTime dateSigned;

        public String eMail
        {
            get { return email; }
            set { email = value; }
        }

        public String Password
        {
            get { return password; }
            set { password = value; }
        }

        public String NickName
        {
            get { return nickname; }
            set { nickname = value; }
        }

        public UserLevel Level
        {
            get { return level; }
            set { level = value; }
        }

        public DateTime DateSigned
        {
            get { return dateSigned; }
            set { dateSigned = value; }
        }

        public User(String Nick, String EMail, String Passwd, DateTime Date)
        {
            NickName = Nick;
            eMail = EMail;
            Password = Passwd;
            Level = UserLevel.Anonymous;
            DateSigned = Date;
        }

        public User(String Nick, String EMail, String Passwd, UserLevel userLevel, DateTime Date)
        {
            NickName = Nick;
            eMail = EMail;
            Password = Passwd;
            Level = userLevel;
            DateSigned = Date;
        }
    }

    public enum UserLevel
    {
        Administrator,
        User,
        Anonymous
    }
}