// SimpleTextTransferDlg.cpp : implementation file
//

#include "stdafx.h"
#include "SimpleTextTransfer.h"
#include "SimpleTextTransferDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

// CSimpleTextTransferDlg dialog

CSimpleTextTransferDlg::CSimpleTextTransferDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSimpleTextTransferDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CSimpleTextTransferDlg::DoDataExchange(CDataExchange* pDX)
{
  CDialog::DoDataExchange(pDX);
  DDX_Control(pDX, ID_EDTTOCLIPBOARD, m_edtToClipboard);
  DDX_Control(pDX, ID_EDTFROMCLIPBOARD, m_edtFromClipboard);
}

BEGIN_MESSAGE_MAP(CSimpleTextTransferDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(ID_BTNCOPY, OnBnClickedBtncopy)
	ON_BN_CLICKED(ID_BTNCUT, OnBnClickedBtncut)
	ON_BN_CLICKED(ID_BTNPASTE, OnBnClickedBtnpaste)
END_MESSAGE_MAP()


// CSimpleTextTransferDlg message handlers

BOOL CSimpleTextTransferDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	m_edtToClipboard.SetWindowText("Sample data to copy to Clipboard");
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CSimpleTextTransferDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{

	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

void CSimpleTextTransferDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

HCURSOR CSimpleTextTransferDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

void CSimpleTextTransferDlg::OnBnClickedBtncopy()
{
	if (UpdateData())
  {
    CString strData;
    m_edtToClipboard.GetWindowText(strData);

	  if (OpenClipboard())
	  {
		  EmptyClipboard();
		  HGLOBAL hClipboardData;
		  hClipboardData = GlobalAlloc(GMEM_DDESHARE, strData.GetLength()+1);
		  char * pchData;
		  pchData = (char*)GlobalLock(hClipboardData);
		  strcpy(pchData, LPCSTR(strData));
		  GlobalUnlock(hClipboardData);
		  SetClipboardData(CF_TEXT,hClipboardData);
		  CloseClipboard();
	  }
  }
}

void CSimpleTextTransferDlg::OnBnClickedBtncut()
{
	OnBnClickedBtncopy();
	m_edtToClipboard.SetWindowText("");
}

void CSimpleTextTransferDlg::OnBnClickedBtnpaste()
{
 if (OpenClipboard()) 
 {
  if (::IsClipboardFormatAvailable(CF_TEXT)
  || ::IsClipboardFormatAvailable(CF_OEMTEXT))
  {
    HANDLE hClipboardData = GetClipboardData(CF_TEXT);

    char *pchData = (char*)GlobalLock(hClipboardData);

    CString strFromClipboard = pchData;
    m_edtFromClipboard.SetWindowText(strFromClipboard);

    GlobalUnlock(hClipboardData);
  }
  else
  { 
    AfxMessageBox("There is no text (ANSI) data on the Clipboard.");
  }

  CloseClipboard();
 }
}