#include "stdafx.h"
#include "SharedMemoryDemo.h"
#include "SharedMemoryDemoDlg.h"
#include "tconvert.h"


#define SHARED_LENGTH 512

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

CSharedMemoryDemoDlg::CSharedMemoryDemoDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSharedMemoryDemoDlg::IDD, pParent)
{
	m_strName = _T("MySharedMemory");
	m_strShared = _T("ABCdef");
   m_SM.Init(_tochar(m_strName),SHARED_LENGTH);
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
   m_nGetTimer = NULL;
}

void CSharedMemoryDemoDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
   CString strTemp = m_strName;
	DDX_Text(pDX, IDC_EDIT_NAME, m_strName);
	DDX_Text(pDX, IDC_EDIT_SHARED, m_strShared);
   if( m_strName != strTemp )
      m_SM.Init(_tochar(m_strName),SHARED_LENGTH);
}

BEGIN_MESSAGE_MAP(CSharedMemoryDemoDlg, CDialog)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON_SET_NAME, OnButtonSetName)
	ON_BN_CLICKED(IDC_BUTTON_SET_DATA, OnButtonSetData)
	ON_BN_CLICKED(IDC_BUTTON_GET_DATA, OnButtonGetData)
	ON_EN_CHANGE(IDC_EDIT_SHARED, OnChangeEditShared)
	ON_BN_CLICKED(IDC_CHECK_GET_TIMER, OnCheckGetTimer)
	ON_WM_TIMER()
END_MESSAGE_MAP()

BOOL CSharedMemoryDemoDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	SetIcon(m_hIcon, TRUE);
	SetIcon(m_hIcon, FALSE);
	
	return TRUE;
}

void CSharedMemoryDemoDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this);

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

HCURSOR CSharedMemoryDemoDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CSharedMemoryDemoDlg::OnButtonSetName() 
{
   UpdateData();
   UpdateData(FALSE);
}

void CSharedMemoryDemoDlg::OnButtonSetData() 
{
   UpdateData();
   m_SM.Lock();
   strcpy( (LPSTR)m_SM.GetData() , _tochar(m_strShared) );
   m_SM.Unlock();
   UpdateData(FALSE);
}

void CSharedMemoryDemoDlg::OnButtonGetData() 
{
   UpdateData();
   m_SM.Lock();
   m_strShared = (LPCSTR)m_SM.GetData();
   m_SM.Unlock();
   UpdateData(FALSE);
}

void CSharedMemoryDemoDlg::OnChangeEditShared() 
{
   UpdateData();
   CSharedMemory::Locker locker(m_SM);
   strcpy( (LPSTR)m_SM.GetData() , _tochar(m_strShared) );
   UpdateData(FALSE);
}

void CSharedMemoryDemoDlg::OnCheckGetTimer() 
{
   UpdateData();
   if(m_nGetTimer)
   {
      KillTimer(m_nGetTimer);
      m_nGetTimer = NULL;
   }
   else
      m_nGetTimer = SetTimer(2,10,NULL);
   UpdateData(FALSE);
}

void CSharedMemoryDemoDlg::OnTimer(UINT nIDEvent) 
{
   if( nIDEvent == m_nGetTimer)
      OnButtonGetData();
	CDialog::OnTimer(nIDEvent);
}