#include <windows.h> 
#include <stdio.h> 
#include <tchar.h>
#include <conio.h>
#include <strsafe.h>

#define BUFSIZE 4096
 
DWORD WINAPI InstanceThread(LPVOID); 
VOID GetAnswerToRequest(LPTSTR, LPTSTR, LPDWORD); 
 
int _tmain(VOID) {
	BOOL fConnected;
	DWORD dwThreadId;
	HANDLE hPipe, hThread;
	LPTSTR lpszPipename = TEXT("\\\\.\\pipe\\mynamedpipe");
	
	for (;;) {
		hPipe = CreateNamedPipe(
			lpszPipename,				// pipe name
			PIPE_ACCESS_DUPLEX,			// read/write access
			PIPE_TYPE_MESSAGE |			// message type pipe
			PIPE_READMODE_MESSAGE |		// message-read mode
			PIPE_WAIT,					// blocking mode
			PIPE_UNLIMITED_INSTANCES,	// max. instances
			BUFSIZE,					// output buffer size
			BUFSIZE,					// input buffer size
			0,							// client time-out
			NULL						// default security attribute
			);
		
		if (hPipe == INVALID_HANDLE_VALUE) {
			printf("CreatePipe failed");
			getch();
			return 0;
		}
		
		fConnected = ConnectNamedPipe(hPipe, NULL) ? TRUE : (GetLastError() == ERROR_PIPE_CONNECTED);
		if (fConnected) {
			hThread = CreateThread(
				NULL,				// no security attribute
				0,					// default stack size
				InstanceThread,		// thread proc
				(LPVOID) hPipe,		// thread parameter
				0,					// not suspended
				&dwThreadId			// returns thread ID
				);

			if (hThread == NULL) {
				printf("CreateThread failed");
				getch();
				return 0;
			}
			else CloseHandle(hThread);
		}
		else {
			CloseHandle(hPipe);
		}
	}
	return 1;
}

DWORD WINAPI InstanceThread(LPVOID lpvParam) {
	TCHAR chRequest[BUFSIZE];
	TCHAR chReply[BUFSIZE];
	DWORD cbBytesRead, cbReplyBytes, cbWritten;
	BOOL fSuccess;
	HANDLE hPipe;
	
	hPipe = (HANDLE) lpvParam;
	
	while (1) {
      fSuccess = ReadFile (
		  hPipe,				// handle to pipe
		  chRequest,			// buffer to receive data
		  BUFSIZE*sizeof(TCHAR),// size of buffer
		  &cbBytesRead,			// number of bytes read
		  NULL					// not overlapped I/O
		  );
	  
	  if (! fSuccess || cbBytesRead == 0) {
		  break;
	  }
      GetAnswerToRequest(chRequest, chReply, &cbReplyBytes);

      fSuccess = WriteFile (
		  hPipe,        // handle to pipe
		  chReply,      // buffer to write from
		  cbReplyBytes, // number of bytes to write
		  &cbWritten,   // number of bytes written
		  NULL          // not overlapped I/O
		  );
	  
	  if (! fSuccess || cbReplyBytes != cbWritten) {
		  break;
	  }
	}
	
	FlushFileBuffers(hPipe);
	DisconnectNamedPipe(hPipe);
	CloseHandle(hPipe);
	
	return 1;
}

VOID GetAnswerToRequest(LPTSTR chRequest, LPTSTR chReply, LPDWORD pchBytes) {
	_tprintf( TEXT("%s\n"), chRequest );
	StringCchCopy( chReply, BUFSIZE, chRequest );
	*pchBytes = (lstrlen(chReply)+1)*sizeof(TCHAR);
}